//B. Pietras, GENP-USC 2014.

#include <iostream>
#include <string>
#include <stdlib.h> 
#include <fstream>
#include <sstream> 
#include <TFile.h>
#include <TH1I.h>
#include <TF1.h>
#include <TCanvas.h>
#include <TSpectrum.h>
#include <TVirtualFitter.h>
#include <TGraph.h>
#include <TStyle.h>
#include <TGraphErrors.h>
#include <TLegend.h>
#include <TMath.h>
#include <TFile.h>
#include <TTree.h>
#include <TApplication.h>

using namespace std;

// c;g++ -o ded ded.cpp `root-config --cflags --glibs` -lSpectrum  && ./ded 

  float swap(float *x, float *y)
    {
    float t;
    t = *x;
    *x = *y;
    *y = t;
    }
    
    int main()
    {    
    ostringstream bell;
    gStyle->SetOptFit();
    gStyle->SetErrorX(0);
	gStyle->SetEndErrorSize(0);
	gStyle->SetTitleFontSize(0.09);
    //gStyle->SetTitleOffset(-1.5); //doesn't work
	
    TApplication *dummy=new TApplication("dummy",0,0);
    const char *names[]={"350V0214","355V0213","360V0212","365V0211","370V0210","375V0209","380V0208","385V0207","390V0206","395V0205","400V0204"}; 
    Float_t nams[11]={350,355,360,365,370,375,380,385,390,395,400};
    Float_t meanL[11][64], meanH[11][64], sigL[11][64], sigH[11][64], resL[11][64], resH[11][64], resLer[11][64], resHer[11][64];
    string path="./hists/";
    string end=".root";
    TString inno,histi;
    TFile *m;
    TTree *T;
    Double_t par[4];
    TGraph *gr[64], *grr[64];
    TF1 *fit[64], *fitt[64];
    char histy[40];
    char hardlines[100];
   
    int j,z,k,thresh,npeaks,nfound,l,hi,lo,tmp,start,stop,inbin;
    Float_t *xpeaks,stp,Z,bins;
    Float_t mean[1],sig[1],meaner[1],siger[1];
    Float_t tumpL[11], tumpLer[11],tumpH[11], tumpHer[11];
    Float_t null[11]={0,0,0,0,0,0,0,0,0,0,0};
    Float_t blinders[1];
    string oof,str,doof,rufe;
    TString sugar,sugarb,topstr;
    char X,tmpstr[3],hymn[30],funname[20];
    TH1F *h[64], *hb[64]; 
    TCanvas *can[11], *cun;
    TF1 *gas[1];
    
    rufe="info_pol2";
	rufe+=".txt";
	bell.str("");
	bell << rufe;
	ofstream outfile(bell.str().c_str());
    cun = new TCanvas("bla","bla",0,0,1700,950);
    cun->Divide(8,8);
    TFile *newfile = new TFile("./hists/pol2.root","recreate");
                                
    for(int i=0;i<11;i++)
	{
	inno=path;
	inno+=names[i];
	inno+=end;
    topstr="./hists/A";
    topstr+=names[i];
    topstr+=".root";
	TFile *m= new TFile(inno);
    can[i] = new TCanvas("blah","blah",0,0,1700,950);
    can[i]->Divide(8,8);
    npeaks=2;
    
          for(int j=0;j<64;j++)
		{
	can[i]->cd(j+1);
	m->cd();
	sprintf(tmpstr,"h_%d",j);
	oof=tmpstr;
	sugar=oof;
	bins=110; 
	h[j]=new TH1F;
	h[j]=(TH1F*)gDirectory->Get(sugar);
	h[j]->GetXaxis()->SetRangeUser(900,1500);
	h[j]->Draw();
	h[j]->ShowBackground(25);
	oof+="_background";
	sugarb=oof;
	hb[j] = (TH1F*)gDirectory->Get(sugarb); 
	h[j]->Add(hb[j],-1);
    hb[j]->Delete();
    h[j]->Draw("][");
    h[j]->Rebin(2);
 
    gas[0]=new TF1("gas[0]","gaus",1112,1232);
    gas[1]=new TF1("gas[1]","gaus",1272,1396); 
      
    gas[0]->SetParameter(0,100);
    gas[0]->SetParameter(1,1172);
    gas[0]->SetParameter(2,25);
    h[j]->GetXaxis()->SetRangeUser(1112,1232);
    h[j]->Fit(gas[0],"R"); 
    
    gas[1]->SetParameter(1,100);
    gas[1]->SetParameter(2,1332);
    gas[1]->SetParameter(3,25);
    h[j]->GetXaxis()->SetRangeUser(1272,1396);
    h[j]->Fit(gas[1],"R");
    
    mean[0]=(gas[0]->GetParameter(1));
    mean[1]=(gas[1]->GetParameter(1));
    meaner[0]=(gas[0]->GetParError(1));
    meaner[1]=(gas[1]->GetParError(1));  
    sig[0]=(gas[0]->GetParameter(2));
    sig[1]=(gas[1]->GetParameter(2));
    siger[0]=(gas[0]->GetParError(2));
    siger[1]=(gas[1]->GetParError(2));
    
    resL[i][j]=235.5*sig[0]/mean[0];
    resH[i][j]=235.5*sig[1]/mean[1];
    
    resLer[i][j]=resL[i][j]*pow((pow((meaner[0]/mean[0]),2)+pow((siger[0]/sig[0]),2)),0.5);
    resHer[i][j]=resH[i][j]*pow((pow((meaner[1]/mean[1]),2)+pow((siger[1]/sig[1]),2)),0.5); 
     
	}
	
	histi=names[i];
	histi+=".pdf";
 	can[i]->SaveAs(histi);
 	newfile->cd();
 	can[i]->Write();
	can[i]->Close();
	}	
	
	for(l=0;l<64;l++) //same as j
	{	
	
	for(k=0;k<11;k++)
	{
	tumpL[k]=resL[k][l];
	tumpLer[k]=resLer[k][l];
    tumpH[k]=resH[k][l];
	tumpHer[k]=resHer[k][l];
	outfile<<l<<"\t"<<nams[k]<<"\t"<<tumpL[k]<<"\t"<<tumpLer[k]<<endl;
	}
    cun->cd(l+1);
	gr[l] = new TGraphErrors(11,nams,tumpL,null,tumpLer);  
	gr[l]->SetMarkerColor(kWhite);
	gr[l]->SetLineColor(4);
    gr[l]->SetLineWidth(0.5);
	gr[l]->SetMarkerStyle(1);
    gr[l]->SetMarkerSize(0.000002);
	sprintf(tmpstr,"h_%d",l);
	gr[l]->SetTitle(tmpstr);
	gr[l]->GetXaxis()->SetTitle("HV");
    gr[l]->GetYaxis()->SetTitle("ERes (%)");
    gr[l]->GetXaxis()->SetTitleOffset(1.9);
    gr[l]->GetYaxis()->SetTitleOffset(1.9);
  //  gr[l]->GetYaxis()->SetRangeUser(3,6);	
   	gr[l]->GetXaxis()->SetLabelSize(0.08);
	gr[l]->GetYaxis()->SetLabelSize(0.08);	
	gr[l]->GetXaxis()->SetTitleSize(0.07);
	gr[l]->GetYaxis()->SetTitleSize(0.07);
	gr[l]->GetXaxis()->CenterTitle();
	gr[l]->GetYaxis()->CenterTitle();
 	gr[l]->Draw("AP");
 	sprintf(hardlines,"fit[%d]",l);
 	fit[l] = new TF1(hardlines,"pol2");
 	gr[l]->Fit(fit[l]);
 	gr[l]->GetFunction(hardlines)->SetLineColor(4);
  	gr[l]->GetFunction(hardlines)->SetLineStyle(2);	
  	gr[l]->GetFunction(hardlines)->SetLineWidth(1);	
    par[0]=par[1]=par[2]=0;
    par[0]=(float)(fit[l]->GetParameter(0));
    par[1]=(float)(fit[l]->GetParameter(1));
    par[2]=(float)(fit[l]->GetParameter(2));
   	grr[l] = new TGraphErrors(11,nams,tumpH,null,tumpHer);  
    grr[l]->SetLineColor(6);
    grr[l]->SetLineWidth(0.5);
	grr[l]->SetMarkerStyle(1);
    grr[l]->SetMarkerSize(0.000002);
    grr[l]->Draw("p");
    sprintf(hardlines,"fitt[%d]",l);
 	fitt[l] = new TF1(hardlines,"pol2");
 	grr[l]->Fit(fitt[l]);
 	grr[l]->GetFunction(hardlines)->SetLineColor(2);
  	grr[l]->GetFunction(hardlines)->SetLineStyle(3);	
  	grr[l]->GetFunction(hardlines)->SetLineWidth(1);	
       
    //  sprintf(hardlines,"h[%d]\t%0.2f\t%0.6f\t%0.6f",l,par[0],par[1],par[2]);
    //  outfile << hardlines << endl;
 	}     
 	cun->SaveAs("pol2.pdf");
 	newfile->cd();
 	cun->Write();
	cun->Close();
	newfile->Write();
	cout<<"\n\n\t\tdone!\n\n";
	return 0;
	}



 
